// *
// * This file contains code copied from Apple's examples. THANKS APPLE!
// *
// PREFERENCE BUTTON ANIMATION (- the pref flipper fade in/out)

var flipShown = false;		// a flag used to signify if the flipper is currently shown or not.
var inPrefs = false; //a flag used to signify if the user is in the preferences or not

// A structure that holds information that is needed for the animation to run.
var animation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, firstElement:null, timer:null};

// mousemove() is the event handle assigned to the onmousemove property on the front div of the widget. 
// It is triggered whenever a mouse is moved within the bounds of your widget.  It prepares the
// preference flipper fade and then calls animate() to performs the animation.

function mousemove (event)
{
	if (!flipShown)			// if the preferences flipper is not already showing...
	{
		if (animation.timer != null)			// reset the animation timer value, in case a value was left behind
		{
			clearInterval (animation.timer);
			animation.timer  = null;
		}
		
		var starttime = (new Date).getTime() - 13; 		// set it back one frame
		
		animation.duration = 500;												// animation time, in ms
		animation.starttime = starttime;										// specify the start time
		animation.firstElement = document.getElementById ('flip');		// specify the element to fade
		animation.timer = setInterval ("animate();", 13);						// set the animation function
		animation.from = animation.now;											// beginning opacity (not ness. 0)
		animation.to = 1.0;														// final opacity
		animate();																// begin animation
		flipShown = true;														// mark the flipper as animated
	}
}

// mouseexit() is the opposite of mousemove() in that it preps the preferences flipper
// to disappear.  It adds the appropriate values to the animation data structure and sets the animation in motion.

function mouseexit (event)
{
	if (flipShown)
	{
		// fade in the flip widget
		if (animation.timer != null)
		{
			clearInterval (animation.timer);
			animation.timer  = null;
		}
		
		var starttime = (new Date).getTime() - 13;
		
		animation.duration = 500;
		animation.starttime = starttime;
		animation.firstElement = document.getElementById ('flip');
		animation.timer = setInterval ("animate();", 13);
		animation.from = animation.now;
		animation.to = 0.0;
		animate();
		flipShown = false;
	}
}


// animate() performs the fade animation for the preferences flipper. It uses the opacity CSS property to simulate a fade.

function animate()
{
	var T;
	var ease;
	var time = (new Date).getTime();
		
	
	T = limit_3(time-animation.starttime, 0, animation.duration);
	
	if (T >= animation.duration)
	{
		clearInterval (animation.timer);
		animation.timer = null;
		animation.now = animation.to;
	}
	else
	{
		ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
		animation.now = computeNextFloat (animation.from, animation.to, ease);
	}
	
	animation.firstElement.style.opacity = animation.now;
}


// these functions are utilities used by animate()

function limit_3 (a, b, c)
{
    return a < b ? b : (a > c ? c : a);
}

function computeNextFloat (from, to, ease)
{
    return from + (to - from) * ease;
}

// these functions are called when the info button itself receives onmouseover and onmouseout events

function enterflip(event)
{
	document.getElementById('fliprollie').style.display = 'block';
}

function exitflip(event)
{
	document.getElementById('fliprollie').style.display = 'none';
}

// showPrefs() is called when the preferences flipper is clicked upon.  It freezes the front of the widget,
// hides the front div, unhides the back div, and then flips the widget over.
//function showPrefs()
//{
//	document.getElementById("CameraName").innerText="";
//
//	window.resizeTo(360,280);
//
//	var front = document.getElementById("front");
//	var back = document.getElementById("back");
//
//	inPrefs = true;
//
//	// Trigger any off-screen actions
//	onhide();
//
//	if (window.widget)
//		widget.prepareForTransition("ToBack");		// freezes the widget so that you can change it without the user noticing
//	
//	front.style.display="none";		// hide the front
//	back.style.display="block";		// show the back
//	
//	if (window.widget)
//	{
//		setTimeout ('widget.performTransition();', 0);		// and flip the widget over	
//	}
//
//		populateList();
//		if (widget.preferenceForKey(createkey("last")) < jaxForm.camList.length)
//			document.jaxForm.camList.options[widget.preferenceForKey(createkey("last"))].selected = true;
//		else
//			document.jaxForm.camList.options[0].selected = true;
//
//	document.getElementById('fliprollie').style.display = 'none';  // clean up the front side - hide the circle behind the info button
//
//
//}
function showPrefs()
{
    document.getElementById("CameraName").innerText="";
	inPrefs = true;
    onhide();
    
	// store the front height and width values to restore on return to front
	gFrontHeight = window.innerHeight;
	gFrontWidth = window.innerWidth;
    
	
	// Two AppleRect objects store the starting and finshing rectangle sizes
	var startingRect = new AppleRect (0, 0, window.innerWidth, window.innerHeight);
	var finishingRect = new AppleRect (0, 0, 360, 280);
	
	// The RectAnimation specifies the range of values and the handler to call at the animator's interval
	var currentRectAnimation = new AppleRectAnimation( startingRect, finishingRect, rectHandler );
    
	// The Animator is the timer for the animation
	var currentAnimator = new AppleAnimator (500, 13);
	
	// Associate the animator and animation
	currentAnimator.addAnimation(currentRectAnimation);
	
	// Set a handler to be called when the animation is done (in this case, flip the widget to its back)
	currentAnimator.oncomplete = flipToBack;
	
	// Once everything is set up, start the animation
	currentAnimator.start();
    
    		populateList();
    		if (widget.preferenceForKey(createkey("last")) < jaxForm.camList.length)
    			document.jaxForm.camList.options[widget.preferenceForKey(createkey("last"))].selected = true;
    		else
    			document.jaxForm.camList.options[0].selected = true;
    
    	document.getElementById('fliprollie').style.display = 'none';  // clean up the front side - hide the circle behind the info button
        

}
function flipToBack()
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");
    
	if (window.widget) {
		widget.prepareForTransition("ToBack");
 	}
    
    front.style.display="none";
    back.style.display="block";
    
    if (window.widget){
        setTimeout ('widget.performTransition();', 0);
		widget.setCloseBoxOffset(13,14);
    }
}

// hidePrefs() is called by the done button on the back side of the widget.  It performs the opposite transition
// as showPrefs() does.
//function hidePrefs()
//{
//
//	var front = document.getElementById("front");
//	var back = document.getElementById("back");
//
//	
//	if (window.widget)
//		widget.prepareForTransition("ToFront");		// freezes the widget and prepares it for the flip back to the front
//	
//	back.style.display="none";		// hide the back
//	front.style.display="block";		// show the front
//	
//	// Get rid of any stale data being shown
//	//had to remove this line because it was complaining about it.
//	//resetDisplay();
//	
//	if (window.widget)
//		setTimeout ('widget.performTransition();', 0);		// and flip the widget back to the front
//
//	width = widget.preferenceForKey(createkey("width"));
//	height = widget.preferenceForKey(createkey("height"));
//		
//	window.resizeTo(width, height);
//	document.getElementById("CameraName").innerText = document.jaxForm.camList.options[(jaxForm.camList.options.selectedIndex)].text;
//
//	updateSize();
//
//
//	// Restart activity
//	inPrefs = false;
//	onshow();
//	
//}

function hidePrefs()
{
    
    inPrefs = false;
    onshow();
    
    var front = document.getElementById("front");
    var back = document.getElementById("back");
	
	if (window.widget) {
		widget.prepareForTransition("ToFront");
 	}
    
    back.style.display="none";
    front.style.display="block";
	
    if (window.widget) {
        setTimeout ('widget.performTransition();', 0);
		widget.setCloseBoxOffset(7,9);
	}
	
	// Once the flip to the front is complete, flipToFront resizes the widget back to its former size.
	setTimeout("flipToFront()", 750);
    
	inPrefs = false;
    onshow();
}

// flipToFront uses another AppleRectAnimation to resize the widget to its previous size
function flipToFront()
{
    	width = widget.preferenceForKey(createkey("width"));
    	height = widget.preferenceForKey(createkey("height"));

    
	var startingRect = new AppleRect (0, 0, 360, 283);
	var finishingRect = new AppleRect (0, 0, width, height);
    
	var currentRectAnimation = new AppleRectAnimation( startingRect, finishingRect, rectHandler );
    
	var currentAnimator = new AppleAnimator (500, 13);
	currentAnimator.addAnimation(currentRectAnimation);
	currentAnimator.start();	
    
    document.getElementById("CameraName").innerText = document.jaxForm.camList.options[(jaxForm.camList.options.selectedIndex)].text;
            //set reload to semi transparent so it does not get stuck from auto cycle mode
//    document.getElementById("CameraName").style.background = "url(semi_transparent.png)"; 
  //  document.getElementById("SmallRefresh").style.background = "transparent"; 

}
//this is what should happen while the animation is taking place.
//move UI elemetns etc.
function rectHandler( rectAnimation, currentRect, startingRect, finishingRect )
{
	window.resizeTo(currentRect.right, currentRect.bottom);
	document.webcam.width = window.innerWidth;
	document.webcam.height = window.innerHeight;
}
