//SlothCam Copyright 2005 Jackson Myers
//If you wanna use this code to learn how to write dashboard widgets, that's cool, just give me credit!

//alert('hello') prints debugging output to console.log

var frame = 1;	//this number will be incremented represent individual cam images for the same URL.
var reload = true; //boolean to represent whether the cam will be reloaded or not.
var urlKey = "http://www.instacam.com/instacamimg/HSMMP/HSMMP_s.jpg" ; //cam URL that is currently in use
var rateKey = 9;  //refresh rate that is currently in use.
var lastPos;
var last_key = null;
var timeoutID;
var currentImage;

//checks if the arrow keys have been pressed and cycles cam in proper direction
function checkArrows(event)
{
	theKey = event.keyCode;
	if(!inPrefs &&  (theKey != last_key) && !document.getElementById('autoCycleCheckBox').checked)
	{

		if(theKey==39)
		{
			window.clearTimeout (timeoutID);
			reload = false;
			nextCam();
			reload=true;
			reloadCam();
		}
		
		else if(theKey==37)
		{
			window.clearTimeout (timeoutID);
			reload = false;
			previousCam();
			reload=true;
			reloadCam();
		}
		
		else if(theKey == 32)
		{
            window.clearTimeout (timeoutID);
			reloadCam();

		}
		
	}
	
	//this is to account for an Apple bug where when you press the arrow once, the function is called twice.
	last_key = theKey;
	setTimeout(function(){last_key = null;}, 50);
}

//do this when the widget is first run
function setup()
{
    
    //this block of screen will disable error.png and instead show most recent webcam image.
    //
    if(!(widget.preferenceForKey("noErrorScreen")))
        widget.setPreferenceForKey(false, "noErrorScreen");
    
    
    //ADD IF STATEMENT HERE, THIS SHOULD BE DONE ONLY IF THE SETTING IS TURNED ON.
    if(widget.preferenceForKey("noErrorScreen")==true)
    {
        document.webcam.onerror = function(){
            document.webcam.src=currentImage.src;
        }
    }
    else if(widget.preferenceForKey("noErrorScreen")==true)
    {
        document.webcam.onerror = function(){
            document.webcam.src="error.png";
        }
    
    }
    
    ////
    //




	if (window.widget) {
		
		//reset the rates if using old prefs.
		if(!widget.preferenceForKey("version"))
		{
			for(i=0; i<numOfURLs(); i++)
			{
				widget.setPreferenceForKey (3, ("rate" + i));
			}
			widget.setPreferenceForKey(3.44, "version")
		}
		else
		if(widget.preferenceForKey("version")!=3.44)
			widget.setPreferenceForKey(3.44, "version")

		
		if (widget.preferenceForKey(createkey("width")))
		{
			window.resizeTo(widget.preferenceForKey(createkey("width")), widget.preferenceForKey(createkey("height")));
			updateSize();
		}
		
		else
		{
			widget.setPreferenceForKey(320, createkey("width"));
			widget.setPreferenceForKey(240, createkey("height"));
			window.resizeTo(320, 240);
			updateSize();
		}

		if (widget.preferenceForKey("autoCycleTime"))
		{
			autoCycleTime = widget.preferenceForKey("autoCycleTime");
		}
		else
			autoCycleTime = 5;
		
		// Set up handlers if running under Dashboard
		widget.onhide = onhide;
		widget.onshow = onshow;
		widget.onremove = onremove;
		
		readPrefs();
		
		//on widget startup, check the box if it was checked last time.
		if (widget.preferenceForKey(createkey("cycle")) == true)
			document.getElementById('cycleCheckBox').checked = true;
		
		if (widget.preferenceForKey(createkey("autoCycle")) == true)
			document.getElementById('autoCycleCheckBox').checked = true;
		

		//setup select list for cam captions
		
		//caption on + notificcation (bottom)
		if (widget.preferenceForKey(createkey("caption")) == 0 || widget.preferenceForKey(createkey("caption")) == null)
		{
			jaxForm2.captionList.options[0].selected = true;
			document.getElementById("CameraName").style.visibility = "visible";
			widget.setPreferenceForKey(0, createkey("caption"));
		}
		//caption only (bottom)
		else if (widget.preferenceForKey(createkey("caption")) ==1)
		{
			jaxForm2.captionList.options[1].selected = true;
			document.getElementById("CameraName").style.visibility = "visible";
		}
		
		//caption on + notification (top)
		else if (widget.preferenceForKey(createkey("caption")) == 2)
		{
			jaxForm2.captionList.options[2].selected = true;
			document.getElementById("CameraName").style.bottom = "auto";
			document.getElementById("CameraName").style.visibility = "visible";
		}
		
		//caption only (top)
		else if (widget.preferenceForKey(createkey("caption")) == 3)
		{
			jaxForm2.captionList.options[3].selected = true;
			document.getElementById("CameraName").style.bottom = "auto";
			document.getElementById("CameraName").style.visibility = "visible";
		}
		
		//caption off
		else if (widget.preferenceForKey(createkey("caption")) == 4)
		{
			jaxForm2.captionList.options[4].selected = true;
			document.getElementById("CameraName").style.visibility = "hidden";
		}
				
		
		
	}
	
	//create done button
	createGenericButton(document.getElementById("doneButton"), "Done", hidePrefs, 67);
	
	reloadCam();
}

//read the preferences when the widget is first run, or if the prefs are reset. 
function readPrefs()
{
	
	//reset options for default cams if no cam0 is set... ie if no preferences exist.
	if (!widget.preferenceForKey("url0"))
	{
		//the first cam is set to the current URL and rate
		
		widget.setPreferenceForKey("http://www.jackson-myers.com/Webcam/webcam.jpg", "url0");
		widget.setPreferenceForKey(9, "rate0");
		widget.setPreferenceForKey("Houston, Texas", "name0");

		widget.setPreferenceForKey("http://www.jackson-myers.com/Webcam/stcatharines/stcatharines_1.jpg", "url1");
		widget.setPreferenceForKey(9, "rate1");
		widget.setPreferenceForKey("St. Catharines, Ontario", "name1");

		widget.setPreferenceForKey("http://221.255.120.171/axis-cgi/jpg/image.cgi", "url2");
		widget.setPreferenceForKey(4, "rate2");
		widget.setPreferenceForKey("Tokyo, Japan", "name2");
		
		widget.setPreferenceForKey("http://www.dublincity.ie/dublintraffic/Site0Camera6.jpg", "url3");
		widget.setPreferenceForKey(10, "rate3");
		widget.setPreferenceForKey("O'Connell Street, Dublin, Ireland", "name3");
	
		widget.setPreferenceForKey("http://abclocal.go.com/three/kabc/webcam/web2-1.jpg", "url4");
		widget.setPreferenceForKey(9, "rate4");
		widget.setPreferenceForKey("Downtown LA, California", "name4");
		
		widget.setPreferenceForKey("http://www.parliamenthill.gc.ca/text/newhillcam.jpg", "url5");
		widget.setPreferenceForKey(7, "rate5");
		widget.setPreferenceForKey("Parliament Hill, Ottawa", "name5");
		
		widget.setPreferenceForKey("http://webcams.galveston.com/docs/casadelmar2006/casadelmarmp.jpg", "url6");
		widget.setPreferenceForKey(5, "rate6");
		widget.setPreferenceForKey("Galveston, Texas", "name6");
		
		widget.setPreferenceForKey("http://test.pancanal.com/webcam/miraflores.jpg", "url7");
		widget.setPreferenceForKey(7, "rate7");
		widget.setPreferenceForKey("Panama Canal, Miraflores Locks", "name7");
		
		widget.setPreferenceForKey("http://static.cbslocal.com/cbs/kpix/webcams/baycam.jpg", "url8");
		widget.setPreferenceForKey(5, "rate8");
		widget.setPreferenceForKey("San Francisco, California", "name8");

		widget.setPreferenceForKey("http://207.251.86.248/cctv26.jpg", "url9");
		widget.setPreferenceForKey(3, "rate9");
		widget.setPreferenceForKey("Broadway, NYC", "name9");

		widget.setPreferenceForKey("http://www.g-townsurf.com/camera/GTownSurf/GTownSurf/GTownSurf.jpg", "url10");
		widget.setPreferenceForKey(9, "rate10");
		widget.setPreferenceForKey("G-Town Surf", "name10");

		populateList();
		
		//put the values of the first default cam in the fields and set as last viewed webcam.
		document.getElementById("urlField").value = jaxForm.camList.options[0].value;
		document.getElementById("nameField").value = jaxForm.camList.options[0].text;
		
		urlKey=jaxForm.camList.options[0].value;
		ratKey=jaxForm.rateList.options[0].value;
		
		widget.setPreferenceForKey(0, createkey("last"));
	}
	
	//select the field.
	document.getElementById("urlField").select();




	//the NaN part takes care of people who used the old version of slothcam where I stores a URL in last instead of a #.
	if((!widget.preferenceForKey((createkey("last"))) || (isNaN(widget.preferenceForKey(createkey("last"))))) & widget.preferenceForKey(createkey("last")) !=0)
	{
		
		
						alert('last does not exist or last is not a number and does not equal zero')

			populateList();
			document.jaxForm.camList.options[0].selected = true;
			document.getElementById("nameField").value =jaxForm.camList.options[0].text;
			
			urlKey = jaxForm.camList.options[0].value;
			document.getElementById("urlField").value = urlKey;
			
			
			jaxForm.rateList.options[9].selected = true;
			rateKey = jaxForm.rateList.options[9].value;
			
			widget.setPreferenceForKey(0, createkey("last"));
			
			document.getElementById("urlField").select();
			
		
		
	}
	
	//set the correct cam info for the case where there is a "last" cam set
	else
	{	
		populateList();		
		
		//this eliminates a bug where the widget tries to load the last cam after it has been deleted and this causes
		//error such as the preferences done button dissappearing.
		//so alyways make sure that the last key is pointing to a real cam before proceding.
		//If not, make it displays the default cam.
		if (widget.preferenceForKey(createkey("last")) < jaxForm.camList.length)
		{
			document.jaxForm.camList.options[widget.preferenceForKey(createkey("last"))].selected = true;
			
			urlKey = jaxForm.camList.options[jaxForm.camList.options.selectedIndex].value;
			document.getElementById("urlField").value = urlKey;
			
			jaxForm.rateList.options[widget.preferenceForKey(("rate" + jaxForm.camList.options.selectedIndex))].selected = true;
			rateKey = jaxForm.rateList.options[jaxForm.rateList.options.selectedIndex].value;
			
			document.getElementById("nameField").value =jaxForm.camList.options[jaxForm.camList.options.selectedIndex].text;		
			
			document.getElementById("urlField").select();
		}
		else
		{
			document.jaxForm.camList.options[0].selected = true;
			urlKey = jaxForm.camList.options[jaxForm.camList.options.selectedIndex].value;
			document.getElementById("urlField").value = urlKey;
			jaxForm.rateList.options[widget.preferenceForKey(("rate" + jaxForm.camList.options.selectedIndex))].selected = true;
			rateKey = jaxForm.rateList.options[jaxForm.rateList.options.selectedIndex].value;
			document.getElementById("nameField").value =jaxForm.camList.options[jaxForm.camList.options.selectedIndex].text;		
			document.getElementById("urlField").select();
			
		}
	}
	
	document.getElementById("CameraName").innerText = document.getElementById("nameField").value;
	
}


function clearPrefs()
{
	theListLength = document.jaxForm.camList.length;
	
	for(i=0; i<theListLength; i++)
	{
		document.jaxForm.camList.options[i]=null;
		widget.setPreferenceForKey (null, ("url" + i));
		widget.setPreferenceForKey (null, ("rate" + i));
		widget.setPreferenceForKey (null, ("name" + i));
	}
	
	widget.setPreferenceForKey (null, createkey("last"));
	widget.setPreferenceForKey (320, createkey("width"));
	widget.setPreferenceForKey (240, createkey("height"));
	
	readPrefs();
}


function onshow() 
{
	
	//create a pref for this widget to say that the cycle box is checked or unchecked.
	if (document.getElementById('cycleCheckBox').checked == true)
		widget.setPreferenceForKey(true, createkey("cycle"));
	else
		widget.setPreferenceForKey(false, createkey("cycle"));
	
	if (document.getElementById('autoCycleCheckBox').checked == true)
	{
		widget.setPreferenceForKey(true, createkey("autoCycle"));
		ratekey=5;
	}
	else
    {
		widget.setPreferenceForKey(false, createkey("autoCycle"));
    }
    
	//caption on + refresh indicator (bottom)
	if (jaxForm2.captionList.selectedIndex == 0)
	{
		document.getElementById("CameraName").style.height = "auto";
		document.getElementById("CameraName").style.right = "auto";
		document.getElementById("CameraName").style.bottom = "0px";
		widget.setPreferenceForKey(0, createkey("caption"));
		document.getElementById("CameraName").style.visibility = "visible";
		document.getElementById("CameraName").innerText = document.getElementById("nameField").value;
	}
	
	//catpion only (bottom)
	if(jaxForm2.captionList.selectedIndex == 1)
	{
		document.getElementById("CameraName").style.height = "auto";
		document.getElementById("CameraName").style.right = "auto";
		document.getElementById("CameraName").style.bottom = "0px";
		document.getElementById("CameraName").style.visibility = "visible";
		document.getElementById("CameraName").innerText = document.getElementById("nameField").value;
		widget.setPreferenceForKey(1, createkey("caption"));
	}
	
	//caption on + refresh indicator (top)
	if (jaxForm2.captionList.selectedIndex == 2)
	{
		document.getElementById("CameraName").style.height = "auto";
		document.getElementById("CameraName").style.bottom = "auto";
		document.getElementById("CameraName").style.right = "auto";
		document.getElementById("CameraName").style.visibility = "visible";
		widget.setPreferenceForKey(2, createkey("caption"));
	}
	
	//caption only (bottom)
	if (jaxForm2.captionList.selectedIndex == 3)
	{
		document.getElementById("CameraName").style.height = "auto";
		document.getElementById("CameraName").style.bottom = "auto";
		document.getElementById("CameraName").style.right = "auto";
		document.getElementById("CameraName").style.visibility = "visible";
		widget.setPreferenceForKey(3, createkey("caption"));
	}
	
	if(jaxForm2.captionList.selectedIndex == 4)
	{
		document.getElementById("CameraName").style.visibility = "hidden";
		widget.setPreferenceForKey(4, createkey("caption"));
	}
	
	if(!inPrefs)
	{
		reload = true;
		reloadCam();
	}
}

//try to populate the list when flipping the widget.
//do this when the widget is hidden.
function onhide() {
	
	if (!inPrefs)
	{
		//if the cycle option is turned on...
		if (document.getElementById('cycleCheckBox').checked == true)
		{
			nextCam();
			document.webcam.src = urlKey;
		}
	}
	
	reload = false;
	window.clearTimeout (timeoutID);

}

function nextCam()
{
if(!inPrefs)
{
	//show next webcam as long as we're not at the end of the list.
	if (jaxForm.camList.options.selectedIndex < (document.jaxForm.camList.length - 1))
	{
		
		document.jaxForm.camList.options[(jaxForm.camList.options.selectedIndex + 1)].selected = true;
		
		urlKey = document.jaxForm.camList.options[(jaxForm.camList.options.selectedIndex)].value;
		document.getElementById("urlField").value = urlKey;
		
		jaxForm.rateList.options[widget.preferenceForKey(("rate" + jaxForm.camList.options.selectedIndex))].selected = true;
		rateKey = jaxForm.rateList.options[jaxForm.rateList.options.selectedIndex].value;
		
		document.getElementById("nameField").value = document.jaxForm.camList.options[(jaxForm.camList.options.selectedIndex)].text;
		
		widget.setPreferenceForKey(jaxForm.camList.options.selectedIndex, createkey("last"));
		
		document.getElementById("urlField").select();
	}
	
	//if we are at the end of the list, go back to the beginning.
	else
	{
		document.jaxForm.camList.options[0].selected = true;
		
		urlKey = document.jaxForm.camList.options[0].value;
		document.getElementById("urlField").value = urlKey;
		
		jaxForm.rateList.options[widget.preferenceForKey("rate0")].selected = true;
		rateKey = jaxForm.rateList.options[jaxForm.rateList.options.selectedIndex].value;
		
		document.getElementById("nameField").value = document.jaxForm.camList.options[0].text;
		
		widget.setPreferenceForKey(0, createkey("last"));
		
		document.getElementById("urlField").select();
		
	}
	
	if (jaxForm2.captionList.selectedIndex == 0 || jaxForm2.captionList.selectedIndex == 1 || jaxForm2.captionList.selectedIndex == 2 || jaxForm2.captionList.selectedIndex == 3 )
		document.getElementById("CameraName").innerText = document.getElementById("nameField").value + " (loading)";	
}
}

function previousCam()
{
	if (jaxForm.camList.options.selectedIndex > 0)
	{
		document.jaxForm.camList.options[(jaxForm.camList.options.selectedIndex - 1)].selected = true;
		
		urlKey = document.jaxForm.camList.options[(jaxForm.camList.options.selectedIndex)].value;
		document.getElementById("urlField").value = urlKey;
		
		jaxForm.rateList.options[widget.preferenceForKey(("rate" + jaxForm.camList.options.selectedIndex))].selected = true;
		rateKey = jaxForm.rateList.options[jaxForm.rateList.options.selectedIndex].value;
		
		document.getElementById("nameField").value = document.jaxForm.camList.options[(jaxForm.camList.options.selectedIndex)].text;
		
		widget.setPreferenceForKey(jaxForm.camList.options.selectedIndex, createkey("last"));
		
		document.getElementById("urlField").select();
	}
	
	else
	{
		document.jaxForm.camList.options[document.jaxForm.camList.length - 1].selected = true;		
		
		urlKey = document.jaxForm.camList.options[jaxForm.camList.options.selectedIndex].value;
		document.getElementById("urlField").value = urlKey;
		
		jaxForm.rateList.options[widget.preferenceForKey(("rate" + jaxForm.camList.options.selectedIndex))].selected = true;
		rateKey = jaxForm.rateList.options[jaxForm.rateList.options.selectedIndex].value;
		
		document.getElementById("nameField").value = document.jaxForm.camList.options[jaxForm.camList.options.selectedIndex].text;
		
		widget.setPreferenceForKey(jaxForm.camList.options.selectedIndex, createkey("last"));
		
		document.getElementById("urlField").select();
	}
	
	if (jaxForm2.captionList.selectedIndex == 0 || jaxForm2.captionList.selectedIndex == 1 || jaxForm2.captionList.selectedIndex == 2 || jaxForm2.captionList.selectedIndex == 3 )
		document.getElementById("CameraName").innerText = document.getElementById("nameField").value + " (loading)";	
	
}

//reload the webcam
function reloadCam()
{	
    //added this 2/9/11. experimental...
    //window.clearTimeout (timeoutID);
    //

	document.getElementById("reload").style.visibility = "hidden";
	document.getElementById("SmallRefresh").style.background = "url(red.png)";

	
	if(jaxForm2.captionList.selectedIndex == 0 || jaxForm2.captionList.selectedIndex == 2 || jaxForm2.captionList.selectedIndex == 4)
    {
        document.getElementById("CameraName").style.background = "url(red.png)";
	}
    
	else if(jaxForm2.captionList.selectedIndex == 1 || jaxForm2.captionList.selectedIndex == 3)
    {
		document.getElementById("CameraName").style.background = "url(semi_transparent.png)";
	}
	
	//incriment the variable that that represents a new frame
	frame++;
	
	//set the image to the new webcam image. ?+frame insures that we get a new frame.
	//this calls another reload, as long as reload is set to 1, which is always the case when the widget is shown.
	if (reload==true)
	{
		
		//if the cycle box is checked them cycle webcams
		if(document.getElementById('autoCycleCheckBox').checked == true && reload==true)
		{			
			//if it's a wvhttp URL
			if(urlKey.indexOf("wvhttp") != -1) 
			{
				//if there's no question mark, use question mark
				if(urlKey.indexOf("?") ==  -1) 
				{
					document.webcam.src = urlKey + "?REQUEST_ID=" + frame;
				}
				
				//if there is a question mark already use &
				else
				{
					document.webcam.src = urlKey + "&REQUEST_ID=" + frame;
					
				}
			}
			//if it's not a wvhttp URL and there is no question mark, use ?
			else if(urlKey.indexOf("?") ==  -1) 
			{
				document.webcam.src = urlKey + "?" + frame;
			}
			//else use & sign
			else
			{
				document.webcam.src = urlKey + "&" + frame;
			}
			
            
            //this is the auto cycle timout. needs to be made to only start the timer onload but also need to fix onload after autocycle is off.
			// timeoutID = self.window.setTimeout('nextCam(); reloadCam();', autoCycleTime*1000);
            document.webcam.onload = function(){
                timeoutID = window.setTimeout('nextCam(); reloadCam();', autoCycleTime*1000);
                
                document.getElementById("CameraName").style.background = "url(semi_transparent.png)"; 
                document.getElementById("SmallRefresh").style.background = "transparent"; 
                document.getElementById("CameraName").innerText = document.getElementById("nameField").value;

            }
			//alert(autoCycleTime);
		}
		
		//otherwise delay X seconds then reload cam
		else
		{
            
			//if it's a wvhttp URL
			if(urlKey.indexOf("wvhttp") != -1) 
			{
				//if there's no question mark, use question mark
				if(urlKey.indexOf("?") ==  -1) 
				{
					document.webcam.src = urlKey + "?REQUEST_ID=" + frame;
				}
				
				//if there is a question mark already use &
				else
				{
					document.webcam.src = urlKey + "&REQUEST_ID=" + frame;
					
				}
			}
            
			//if it's not a wvhttp URL and there is no question mark, use ?
			else if(urlKey.indexOf("?") ==  -1) 
			{
				document.webcam.src = urlKey + "?" + frame;
			}
			//else use & sign
			else
			{
				document.webcam.src = urlKey + "&" + frame;
			}
            
                //reset onload in case it was changed by the autocycle setting. 
                document.webcam.onload = function(){
                    document.getElementById("CameraName").style.background = "url(semi_transparent.png)"; 
                    document.getElementById("SmallRefresh").style.background = "transparent"; 
                    document.getElementById("CameraName").innerText = document.getElementById("nameField").value;
                    
                    //save current webcam image inside widget package
                    currentImage = new Image();
                    currentImage.src=urlKey;
                   
                    // command='/usr/bin/curl '+urlKey+' > currentimage.jpg';
                    //foo=widget.system(command,null);
                    
                }

			
            timeoutID = self.setTimeout('reloadCam()', jaxForm.rateList.options[jaxForm.rateList.selectedIndex].value * 1000);

		}

	}
}

function onLoadFunctions()
{
    alert('ONLOAD FUNCTIONS LOADED');
    document.getElementById("CameraName").style.background = "url(semi_transparent.png)"; 
    document.getElementById("SmallRefresh").style.background = "transparent"; 
    document.getElementById("CameraName").innerText = document.getElementById("nameField").value;

}


//go to the website.
function goToUrl(url)
{
	if (window.widget)
	{
		widget.openURL(url);
	}
}

//change the URL that SlothCam displays when the select list option is changed.
function changeURL()
{
	//alert(widget.preferenceForKey(("rate"+jaxForm.camList.options.selectedIndex)))
	
	//update the url and rate for the new cam URL.
	
	if(widget.preferenceForKey(("name"+jaxForm.camList.options.selectedIndex)))
	{
		
		urlKey = document.jaxForm.camList.options[jaxForm.camList.options.selectedIndex].value;
		document.getElementById("urlField").value = urlKey;
		
		//update the fields to reflect the new refresh rate.
		jaxForm.rateList.options[widget.preferenceForKey(("rate"+jaxForm.camList.options.selectedIndex))].selected = true;
		rateKey = document.jaxForm.rateList.options[document.jaxForm.rateList.options.selectedIndex].value;
		
		//update the fields to reflect the new cam name.	
		document.getElementById("nameField").value = document.jaxForm.camList.options[jaxForm.camList.options.selectedIndex].text;	
		
		//set pref for last cam viewed to this cam
		
		widget.setPreferenceForKey(jaxForm.camList.options.selectedIndex, createkey("last"));
		
		//load one image of the new cam so that when the user preses done, the correct cam is there.
		frame++;
		document.webcam.src = urlKey + "?" + frame;
		
		//select the field
		document.getElementById("urlField").select();
	}
	else
	{
		populateList();
	}
}

//add a new URL to the select list when the button is clicked.
function addURL(newURL)
{
	lengthOfList = document.jaxForm.camList.length;
	
	urlKey = document.getElementById("urlField").value;
	
	//update the fields to reflect the new cam URL.
	widget.setPreferenceForKey(document.getElementById("urlField").value, ("url" + lengthOfList));
	
	widget.setPreferenceForKey(document.getElementById("nameField").value, ("name" + lengthOfList));	
	
	widget.setPreferenceForKey(jaxForm.rateList.options.selectedIndex, ("rate" + lengthOfList));
	rateKey = jaxForm.rateList.options[jaxForm.rateList.options.selectedIndex].value;
	
	//set pref for last cam viewed to this cam
	widget.setPreferenceForKey(lengthOfList, createkey("last"));
	
	//populate the list with the new cam.
	populateList();
	
	//make the new URL selected.
	document.jaxForm.camList.options[lengthOfList].selected = true;
	
	//load one image of the new cam so that when the user preses done, the correct cam is there.
	frame++;
	document.webcam.src = urlKey + "?" + frame;
	
	
	//select the field
	document.getElementById("urlField").select();
}


//count the # of URLs  in the prefs
function numOfURLs()
{
	var i =0;
	
	while (widget.preferenceForKey("url" + i))
	{	
		i++;
	}
	
	return i;
}


//fills in the select list with the option at the end of the list being selected
function populateList()
{
	for(i=0; i<numOfURLs(); i++)
	{
		if(widget.preferenceForKey("name" + i))
			document.jaxForm.camList.options[i]=new Option(widget.preferenceForKey("name" + i), widget.preferenceForKey("url" + i), true);
		else
			document.jaxForm.camList.options[i]=new Option("No Camera Name", widget.preferenceForKey("url" + i), true);
	}
	
	if(jaxForm.camList.length >i)
	{
		for(i; i<jaxForm.camList.length; i++)
		{
			document.jaxForm.camList.options[i]= null;
		}
		
		changeURL();
	}
			
			
		document.getElementById("urlField").select();	
}


//creates a unique key for each widget instance so that individual widgets can have their own last preference.
function createkey(key)
{
	return widget.identifier + "-" + key;
}


//deletes the current URL
function clearURL()
{
	if (window.widget)
	{
		
		//only do this if there is less than 1 URL in the select list
		if (document.jaxForm.camList.length >1)
		{
			//Detete the cam from prefs and select list
			toDelete = document.jaxForm.camList.options.selectedIndex;
			widget.setPreferenceForKey (null, ("url" + toDelete));
			widget.setPreferenceForKey (null, ("rate" + toDelete));
			widget.setPreferenceForKey (null, ("name" + toDelete));
			
			document.jaxForm.camList.options[toDelete]= null;
			
			//shift list and renumber after removing
			for  (i=toDelete; i<document.jaxForm.camList.length; i++)
			{
				nextURL = widget.preferenceForKey("url" + (i + 1));
				nextRate = widget.preferenceForKey("rate" + (i + 1));
				nextName = widget.preferenceForKey("name" + (i+1));
				
				widget.setPreferenceForKey (nextURL, ("url" + i));
				widget.setPreferenceForKey (nextRate, ("rate" + i));
				widget.setPreferenceForKey (nextName, ("name" + i));
			}
			
			//erase last element after shifting list
			widget.setPreferenceForKey (null, ("url"+ document.jaxForm.camList.length) );
			widget.setPreferenceForKey (null, ("rate"+ document.jaxForm.camList.length) );
			widget.setPreferenceForKey (null, ("name"+ document.jaxForm.camList.length) );
			
			widget.setPreferenceForKey(null, createkey("last"));
		}
	}
	
	//make the previous cam selected as long as its not the first cam, otherwise keep the first cam selected
	if(toDelete!=0)
	{
		document.jaxForm.camList.options[(toDelete-1)].selected = true;
		widget.setPreferenceForKey((toDelete -1), createkey("last"));
	}
	else
	{
		document.jaxForm.camList.options[(0)].selected = true;
		widget.setPreferenceForKey(0, createkey("last"));
	}
	
	//change the URL to the URL that is selected now.
	changeURL();
}

//update the current refresh rate and associated preferences if user modifies refresh rate field and presses enter.
function updateRate(event)
{
	widget.setPreferenceForKey(jaxForm.rateList.options.selectedIndex, ("rate"+jaxForm.camList.options.selectedIndex))
	rateKey = jaxForm.rateList.options[jaxForm.rateList.options.selectedIndex].value;
	
}

//update the current URL and associated preferences if user modifies refresh rate field and presses enter.
function updateURL(event)
{
	//keycode 13 is enter key
    if (event.keyCode==13)
	{
		urlKey = document.getElementById("urlField").value;
		widget.setPreferenceForKey(document.getElementById("urlField").value, ("url" + document.jaxForm.camList.options.selectedIndex));
		document.jaxForm.camList.options[document.jaxForm.camList.options.selectedIndex].value = document.getElementById("urlField").value ;
	}
	//load one image of the new cam so that when the user preses done, the correct cam is there.
	frame++;
	document.webcam.src = urlKey + "?" + frame;
	
}

function updateName(event)
{
    if (event.keyCode==13)
	{
		widget.setPreferenceForKey(document.getElementById("nameField").value, ("name" + document.jaxForm.camList.options.selectedIndex));
		document.jaxForm.camList.options[document.jaxForm.camList.options.selectedIndex].text = document.getElementById("nameField").value ;
	}
}


//
//RESIZE CODE BORROWED FROM APPLE'S EXAMPLES. THANKS, APPLE!
//
//when the user clicks on the resize box, this function is called.
function mouseDown(event)
{
	var x = event.x + window.screenX;		// the placement of the click
	var y = event.y + window.screenY;
	
	document.addEventListener("mousemove", mouseMove, true);  	// begin tracking the move
	document.addEventListener("mouseup", mouseUp, true);		// and notify when the drag ends
	
	lastPos = {x:x, y:y};		// track where the initial mouse down was, for later comparisons
	
	event.stopPropagation();
	event.preventDefault();
}


// mouseMove performs the actual resizing of the widget.  It is called after mouseDown
// activates it and every time the mouse moves.
function mouseMove(event)
{
	var screenX = event.x + window.screenX;		// retrieves the current mouse position
	var screenY = event.y + window.screenY;
	
	var deltaX = 0;		// will hold the change since the last mouseMove event
	var deltaY = 0;
	
	if ( (window.outerWidth + (screenX - lastPos.x)) >= 160 ) { 		// sets a minimum width constraint
		deltaX = screenX - lastPos.x;								// if we're greater than the constraint,
		lastPos.x = screenX;										// save the change and update our past position
	}
	
	if ( (window.outerHeight + (screenY - lastPos.y)) >= 120 ) {		// setting contrains for the heght
		deltaY = screenY - lastPos.y;
		lastPos.y = screenY;
	}
	
	//if the shift key is pressed, let the user specify the aspect ratio
	if(event.shiftKey)
	{
		window.resizeBy(deltaX, deltaY);	// resizes the widget to follow the mouse movement
		updateSize();
	}
	
	//otherwise make sure the aspect ratio of (4/3) stays.
	else
	{	
		if(deltaX % 4 != 0)
		{
			while (deltaX % 4 != 0)
			{
				if(deltaX > 0)
					deltaX++;
				
				if(deltaX < 0)
					deltaX--;
			}
			
			window.resizeBy(deltaX, Math.round(deltaX * (3/4)));
		}
		else
			window.resizeBy(deltaX, Math.round(deltaX * (3/4)));
		
		// updates the size of the image
		updateSize();
	}	
	
	event.stopPropagation();
	event.preventDefault();
}

// mouseUp is called when the user stops resizing the widget.  It removes the mouseMove and
// mouseUp event handlers, so that the widget doesn't continute resizing (because the mouse
// button is now up
function mouseUp(event)
{
	document.removeEventListener("mousemove", mouseMove, true);
	document.removeEventListener("mouseup", mouseUp, true);	
	
	event.stopPropagation();
	event.preventDefault();
	
	//	alert('setting width=' + window.innerWidth + 'and height='+ window.innerHeight);
	
	widget.setPreferenceForKey(window.innerWidth, createkey("width"));
	widget.setPreferenceForKey(window.innerHeight, createkey("height"));	
}


// Updates the webcam image size to be the same as the current widget size
function updateSize()
{
	event.stopPropagation();
	event.preventDefault();
	
	document.webcam.width = window.innerWidth;
	document.webcam.height = window.innerHeight;
	

}

//When you close this widget, remove the preference that are not needed.
function onremove()
{
	if (window.widget)
	{
		widget.setPreferenceForKey (null, createkey("last"));
		widget.setPreferenceForKey (null, createkey("cycle"));
		widget.setPreferenceForKey (null, createkey("autoCycle"));
		widget.setPreferenceForKey (null, createkey("width"));
		widget.setPreferenceForKey (null, createkey("height"));
		widget.setPreferenceForKey (null, createkey("caption"));
	}
}

function listChanged()
{
	changeURL(); 
	populateList(); 
	document.jaxForm.camList.options[widget.preferenceForKey(createkey("last"))].selected = true;
}

function flashClick(event)
{
	if(widget.preferenceForKey("flash") == true || widget.preferenceForKey("flash") == null)
	{
		document.getElementById("flash").innerText = "Flash Disabled";
		widget.setPreferenceForKey (false, "flash");
	}
	else
	{
		document.getElementById("flash").innerText = "Flash Enabled";
		widget.setPreferenceForKey (true, "flash");
	}
	
}